SystemOrganization addCategory: #'TOC-Declaration-Core'!
SystemOrganization addCategory: #'TOC-Declaration-Visitor'!

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 12/20/2011 14:39'!
loadDeclarationIn: "(TOProject)"toc 
	snapshot definitions do: [:def |
		def loadDeclarationIn: toc mcVersion: self.] 
	! !

Object subclass: #TOProject
	instanceVariableNames: 'projectName selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProject class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 20:04'!
matchSelector: selector
	('is#*' match: selector) ifFalse: [^false].
	(selector endsWith: ':') ifTrue: [^false].
	(selector at: 3) isUppercase ifFalse: [^false].
	^true! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 22:14'!
addSelector: "(MCMthDef)" mthDef
	|tos|
	tos:=selectors at: mthDef tocName ifAbsent:[ 
		selectors at: mthDef tocName put: (TOSelector newFrom: mthDef). 
		^ self]. "1st occ."
	
	"2nd+ occ. [thing better this]"
	tos validate: mthDef 
	! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 23:01'!
copyMixPredicates
	|neo|
	neo := self class new projectName: self projectName .
	self mixPredicates do: [:tos| neo selectors at: tos mthDef tocName put: tos].
	^ neo! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 23:04'!
hasMixPredicates
	selectors do: [:tos |
		(selectors keys select:[:k | 
			(k endsWith: tos selector) and:[k ~= tos mthDef tocName]]) do:[:key|
				tos class ~= (selectors at: key) class ifTrue:[^true]]].
	^ false! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 19:48'!
initialize 
	selectors := Dictionary new.! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 19:58'!
matchSelector: selector
	^ self class matchSelector: selector ! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 23:04'!
mixPredicates
	|mix|
	mix := Set new.
	selectors do: [:tos |
		(selectors keys select:[:k | 
			(k endsWith: tos selector) and:[k ~= tos mthDef tocName]]) do:[:key|
				tos class ~= (selectors at: key) class ifTrue:[mix add: tos]]].
	^ mix! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:28'!
printString 
	|name|
	name := projectName,' ',(selectors size asString),'#'.
	(selectors size) > 0 ifTrue:  [
		{#isTypePredicate -> 'type' . #isTypeState->'state' . #isExtra -> 'extra'} do: [:pair|
			name := name, ', ',(selectors select: pair key) size asString,(pair value)]].
	^ name! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName
	^ projectName! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName: anObject
	projectName := anObject! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
selectors
	^ selectors! !

Object subclass: #TOSelector
	instanceVariableNames: 'mthDef validated unvalidated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

TOSelector subclass: #TOExtraSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOExtraSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Extra'! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isExtra
	^true! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:32'!
validate: def
	(TOTypeStateSelector visitorClass accept: def source) 
		ifTrue: [self unvalidated add: def. ^self.].
	(TOTypePredicateSelector visitorClass accept: def source) 
		ifTrue: [self unvalidated add: def. ^self.].
	self validated add: def.! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:00'!
newFrom: mthDef
	"order define precendece"
	{TOTypeStateSelector . TOTypePredicateSelector} do: [:tot|
		(tot visitorClass accept: mthDef source) ifTrue: [^ tot new mthDef: mthDef] ].
	^ TOExtraSelector new mthDef: mthDef  ! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ self subclassResponsibility ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:41'!
<= another
	self selector  = another selector ifFalse: [^ self selector <= another selector].
	^ self mthDef tocName <= another mthDef tocName ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:36'!
duplicatesLength
	|n|
	n:= validated ifNil: [0] ifNotNil: [validated size]. 
	n:= n + (unvalidated ifNil: [0] ifNotNil: [unvalidated size]). 
	^ n! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isExtra
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isTypePredicate
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isTypeState
	^false! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/16/2011 20:05'!
mthDef
	^ mthDef! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:07'!
mthDef: def
	mthDef := def! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 11:30'!
printString 
	^ self class shortName, '[',mthDef tocName,']'! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:06'!
selector
	^ mthDef selector! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
unvalidated 
	^ unvalidated ifNil: [unvalidated := Set new.]! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 17:04'!
validate: def
	((self class visitorClass accept: def source) 
		ifTrue: [self validated] ifFalse:[ self unvalidated]) add: def! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
validated 
	^ validated ifNil: [validated := Set new.]! !

TOSelector subclass: #TOTypePredicateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Type'! !

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypePredicateVisitor! !

!TOTypePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isTypePredicate 
	^true! !

TOSelector subclass: #TOTypeStateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOTypeStateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:33'!
shortName 
	^ 'State'! !

!TOTypeStateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypeStateVisitor! !

!TOTypeStateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isTypeState 
	^ true! !

Dictionary subclass: #TOProjectDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:40'!
allDuplicates
	^ self inject: Dictionary new into: [:dic :pot | 
		(pot selectors) do: [:tos | |v n|
			n := tos duplicatesLength.
			n > 0 ifTrue: [
				v:= dic at: n ifAbsentPut: [OrderedCollection new].
				v add: tos]].
		dic].! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 10:38'!
allExtras
	^ self  inject: SortedCollection new into: [:sor :pot|
		sor addAll: (pot selectors select: #isTypeState) ; yourself].! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 22:54'!
allProjectsWithMixPredicates
	^ (self select: #hasMixPredicates) collect: #copyMixPredicates! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 17:03'!
allProjectsWithTypePredicates
	^ self select: [:top | (top selectors select: #isTypePredicate) size > 0]! !

!RBParser class methodsFor: '*toc-declaration' stamp: 'OzC 12/16/2011 20:57'!
permissiveParseMethod: source
	[^ RBParser parseMethod: source] on: Error do: [:e | Transcript cr; show: e].
	^ RBParser parseMethod: 'notValidMethodFailToParse'! !

RBProgramNodeVisitor subclass: #TODeclarationVisitor
	instanceVariableNames: 'accepted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

TODeclarationVisitor subclass: #TODTypePredicateVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypePredicateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:42'!
acceptReturnNode: aReturnNode 
	|lit|
	lit := aReturnNode value.
	((lit isLiteralNode) and: [lit value isKindOf: Boolean]) ifTrue: [accepted := true]
	! !

TODeclarationVisitor subclass: #TODTypeStateVisitor
	instanceVariableNames: 'hasReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:35'!
acceptReturnNode: aReturnNode 
	hasReturn := true.
	super acceptReturnNode: aReturnNode .! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:24'!
acceptVariableNode: aVariableNode
	|name |
	name := aVariableNode name.
	(#(self super) includes: name) ifTrue: [ accepted := true. ^self.].
	
	"dependent on FEFI"
	aVariableNode  isLocallyBound ifFalse: [ accepted := true]
	
	 
	 ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:34'!
accepted 
	^ accepted & hasReturn ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:32'!
initialize 
	super initialize .
	hasReturn := false.! !

!TODeclarationVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:00'!
accept: source
	^ self new 
		visitNode: (RBParser permissiveParseMethod: source) ; 
		accepted
	 ! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
accepted 
	^ accepted ! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
initialize 
	super initialize .
	accepted := false.! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 00:52'!
retrieveDeclarations
	|doc|
	doc:= TOProjectDictionary new.
	projects do: [:p| |dot name|
		name := p projectName.
		dot := doc at: name ifAbsentPut: (TOProject new projectName: name).
		p versions last mcVersion loadDeclarationIn: dot.
		] displayingProgress: 'Reading projects'.
	^doc! !

!MCDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/20/2011 14:39'!
loadDeclarationIn: toc mcVersion: mcVersion
	! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
fullClassName2

	^ self classIsMeta
		ifFalse: [self className]
		ifTrue: [self className, ' class']! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/20/2011 14:40'!
loadDeclarationIn: toc mcVersion: mc
	(toc matchSelector: self selector) ifFalse: [^self].
	toc addSelector: ((self as: TOMCMethodDefinition) mcVersion: mc). 
	
	! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
tocName 
	^ self fullClassName2 ,'>>',selector ! !

MCMethodDefinition subclass: #TOMCMethodDefinition
	instanceVariableNames: 'mcVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOMCMethodDefinition methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 14:47'!
browse "cloned from FMthDef>>browse"
	|browser|
	browser := MCSnapshotBrowser forSnapshot: self mcVersion snapshot.
	self classIsMeta ifTrue: [browser switchBeClass] ifFalse: [browser switchBeInstance].
	browser
		categorySelection: (browser categoryList indexOf: self packageSelection);
		classSelection: (browser classList indexOf: self className);
		protocolSelection: (browser protocolList indexOf: self category);
		methodSelection: (browser methodList indexOf: self selector);
		show! !

!TOMCMethodDefinition methodsFor: 'accessing' stamp: 'OzC 12/20/2011 14:37'!
mcVersion
	^ mcVersion! !

!TOMCMethodDefinition methodsFor: 'accessing' stamp: 'OzC 12/20/2011 14:37'!
mcVersion: anObject
	mcVersion := anObject! !

!TOMCMethodDefinition methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 14:48'!
packageSelection "TODO:"
	"cloned from FMthDef>>pkgAsCtgSelection"
	self isExtensionMethod ifTrue: [^ '*Extensions'].
	^ (self mcVersion atClsDef: self className) category! !
